/*************************************************************************************************
 * dpm
 * Depotδġ
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    QDBMδAPIӤΥץꥱΤδġǤ롣
 *    ʲν񼰤Ѥ롣name ϥե̾key ϥval ͤǤ롣
 *       - ǡ١ե롣
 *            dpm create [-v] [-bnum num] name
 *       - ͤб쥳ɤɲä롣
 *            dpm put [-v] [-kx] [-vx] [-keep] [-cat] name key val
 *       - б쥳ɤ롣
 *            dpm out [-v] [-kx] name key
 *       - б쥳ɤͤɸϤ롣
 *            dpm get [-v] [-kx] [-start num] [-max num] [-ox] [-n] name key
 *       - ǡ١ƤΥ쥳ɤΥԤǶڤäɸϤ롣
 *            dpm list [-v] [-ox] name
 *       - ǡ١Ŭ롣
 *            dpm optimize [-v] [-bnum num] name
 *       - ǡ١λ¿ʾɸϤ롣
 *            dpm inform [-v] name
 *       - QDBMΥСɸϤ롣
 *            dpm version
 *    ƥץϰʲεǽġ
 *         -v          ǥХåϤ롣
 *         -bnum num   Хåǿ num ˻ꤹ롣
 *         -kx         ñ̤ΣʿˤХʥɽȤ key 򰷤
 *         -vx         ñ̤ΣʿˤХʥɽȤ val 򰷤
 *         -keep       ¸Υ쥳ɤȥʣ˾񤭤˥顼ˤ롣
 *         -cat        ¸Υ쥳ɤȥʣͤɲä롣
 *         -start      ͤФǡγϥեåȤꤹ롣
 *         -max        ͤФǡκĹꤹ롣
 *         -ox         ñ̤ΣʿˤХʥɽȤɸϤԤ
 *         -n          ɸϤղäʸνϤ롣
 *    ˽λ 0 ֤顼Фʳ֤ͤƽλ롣
 *************************************************************************************************/


#include "depot.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ALIGNSIZE      8            /* 饤Ȥδܥ */
#define ALIGNUNIT      64           /* 饤ȤΥ˥åȥ */


/* Хѿ */
const char *progname;               /* ץ̾ */


/* ؿץȥ */
int main(int argc, char **argv);
void usage(void);
char *hextoobj(const char *str, int *sp);
int runcreate(int argc, char **argv);
int runput(int argc, char **argv);
int runout(int argc, char **argv);
int runget(int argc, char **argv);
int runlist(int argc, char **argv);
int runoptimize(int argc, char **argv);
int runinform(int argc, char **argv);
void pdperror(const char *name);
void printobjhex(const char *obj, int size);
int docreate(const char *name, int bnum);
int doput(const char *name, const char *kbuf, int ksiz, const char *vbuf, int vsiz, DPDMODE dmode);
int doout(const char *name, const char *kbuf, int ksiz);
int doget(const char *name, const char *kbuf, int ksiz, int start, int max, int ox, int nb);
int dolist(const char *name, int ox);
int dooptimize(const char *name, int bnum);
int doinform(const char *name);


/* ᥤ롼 */
int main(int argc, char **argv){
  int rv;
  progname = argv[0];
  if(argc < 2) usage();
  rv = 0;
  if(!strcmp(argv[1], "create")){
    rv = runcreate(argc, argv);
  } else if(!strcmp(argv[1], "put")){
    rv = runput(argc, argv);
  } else if(!strcmp(argv[1], "out")){
    rv = runout(argc, argv);
  } else if(!strcmp(argv[1], "get")){
    rv = runget(argc, argv);
  } else if(!strcmp(argv[1], "list")){
    rv = runlist(argc, argv);
  } else if(!strcmp(argv[1], "optimize")){
    rv = runoptimize(argc, argv);
  } else if(!strcmp(argv[1], "inform")){
    rv = runinform(argc, argv);
  } else if(!strcmp(argv[1], "version") || !strcmp(argv[1], "--version")){
    printf("Powered by QDBM version %s\n", dpversion);
    printf("Copyright (c) 2000-2003 Mikio Hirabayashi\n");
    rv = 0;
  } else {
    usage();
  }
  return rv;
}


/* ˡåϤƽλ롣 */
void usage(void){
  fprintf(stderr, "%s: administration utility for Depot\n\n", progname);
  fprintf(stderr, "usage:\n");
  fprintf(stderr, "  %s create [-v] [-bnum num] name\n", progname);
  fprintf(stderr, "  %s put [-v] [-kx] [-vx] [-keep] [-cat] name key val\n", progname);
  fprintf(stderr, "  %s out [-v] [-kx] name key\n", progname);
  fprintf(stderr, "  %s get [-v] [-kx] [-start num] [-max num] [-ox] [-n] name key\n", progname);
  fprintf(stderr, "  %s list [-v] [-ox] [-n] name\n", progname);
  fprintf(stderr, "  %s optimize [-v] [-bnum num] name\n", progname);
  fprintf(stderr, "  %s inform [-v] name\n", progname);
  fprintf(stderr, "  %s version\n", progname);
  exit(1);
}


/* ɽʸ󤫤Хʥꥪ֥ȤȤΰ֤ */
char *hextoobj(const char *str, int *sp){
  char *buf, mbuf[3];
  int len, i, j;
  len = strlen(str);
  if(!(buf = malloc(len + 1))) return NULL;
  j = 0;
  for(i = 0; i < len; i += 2){
    while(strchr(" \n\r\t\f\v", str[i])){
      i++;
    }
    if((mbuf[0] = str[i]) == '\0') break;
    if((mbuf[1] = str[i+1]) == '\0') break;
    mbuf[2] = '\0';
    buf[j++] = strtol(mbuf, NULL, 16);
  }
  buf[j] = '\0';
  *sp = j;
  return buf;
}


/* createΰϤ롣 */
int runcreate(int argc, char **argv){
  char *name;
  int i, bnum, rv;
  name = NULL;
  bnum = -1;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-bnum")){
        if(++i >= argc) usage();
        bnum = atoi(argv[i]);
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = docreate(name, bnum);
  return rv;
}


/* putΰϤ롣 */
int runput(int argc, char **argv){
  char *name, *key, *val, *kbuf, *vbuf;
  int i, kx, vx, ksiz, vsiz, rv;
  DPDMODE dmode;
  name = NULL;
  kx = FALSE;
  vx = FALSE;
  key = NULL;
  val = NULL;
  dmode = DP_DOVER;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-kx")){
        kx = TRUE;
      } else if(!strcmp(argv[i], "-vx")){
        vx = TRUE;
      } else if(!strcmp(argv[i], "-keep")){
        dmode = DP_DKEEP;
      } else if(!strcmp(argv[i], "-cat")){
        dmode = DP_DCAT;
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else if(!key){
      key = argv[i];
    } else if(!val){
      val = argv[i];
    } else {
      usage();
    }
  }
  if(!name || !key || !val) usage();
  if(kx){
    kbuf = hextoobj(key, &ksiz);
  } else {
    kbuf = strdup(key);
    ksiz = -1;
  }
  if(vx){
    vbuf = hextoobj(val, &vsiz);
  } else {
    vbuf = strdup(val);
    vsiz = -1;
  }
  if(kbuf && vbuf){
    rv = doput(name, kbuf, ksiz, vbuf, vsiz, dmode);
  } else {
    fprintf(stderr, "%s: out of memory\n", progname);
    rv = 1;
  }
  free(kbuf);
  free(vbuf);
  return rv;
}


/* outΰϤ롣 */
int runout(int argc, char **argv){
  char *name, *key, *kbuf;
  int i, kx, ksiz, rv;
  name = NULL;
  kx = FALSE;
  key = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-kx")){
        kx = TRUE;
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else if(!key){
      key = argv[i];
    } else {
      usage();
    }
  }
  if(!name || !key) usage();
  if(kx){
    kbuf = hextoobj(key, &ksiz);
  } else {
    kbuf = strdup(key);
    ksiz = -1;
  }
  if(kbuf){
    rv = doout(name, kbuf, ksiz);
  } else {
    fprintf(stderr, "%s: out of memory\n", progname);
    rv = 1;
  }
  free(kbuf);
  return rv;
}


/* getΰϤ롣 */
int runget(int argc, char **argv){
  char *name, *key, *kbuf;
  int i, kx, ox, nb, start, max, ksiz, rv;
  name = NULL;
  kx = FALSE;
  ox = FALSE;
  nb = FALSE;
  start = 0;
  max = -1;
  key = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-kx")){
        kx = TRUE;
      } else if(!strcmp(argv[i], "-ox")){
        ox = TRUE;
      } else if(!strcmp(argv[i], "-n")){
        nb = TRUE;
      } else if(!strcmp(argv[i], "-start")){
        if(++i >= argc) usage();
        start = atoi(argv[i]);
      } else if(!strcmp(argv[i], "-max")){
        if(++i >= argc) usage();
        max = atoi(argv[i]);
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else if(!key){
      key = argv[i];
    } else {
      usage();
    }
  }
  if(!name || !key || start < 0) usage();
  if(kx){
    kbuf = hextoobj(key, &ksiz);
  } else {
    kbuf = strdup(key);
    ksiz = -1;
  }
  if(kbuf){
    rv = doget(name, kbuf, ksiz, start, max, ox, nb);
  } else {
    fprintf(stderr, "%s: out of memory\n", progname);
    rv = 1;
  }
  free(kbuf);
  return rv;
}


/* listΰϤ롣 */
int runlist(int argc, char **argv){
  char *name;
  int i, ox, rv;
  name = NULL;
  ox = FALSE;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-ox")){
        ox = TRUE;
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = dolist(name, ox);
  return rv;
}


/* optimizeΰϤ롣 */
int runoptimize(int argc, char **argv){
  char *name;
  int i, bnum, rv;
  name = NULL;
  bnum = -1;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else if(!strcmp(argv[i], "-bnum")){
        if(++i >= argc) usage();
        bnum = atoi(argv[i]);
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = dooptimize(name, bnum);
  return rv;
}


/* informΰϤ롣 */
int runinform(int argc, char **argv){
  char *name;
  int i, rv;
  name = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-v")){
        dpdbgfd = 2;
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = doinform(name);
  return rv;
}


/* depotΥ顼åϤ롣 */
void pdperror(const char *name){
  fprintf(stderr, "%s: %s: %s\n", progname, name, dperrmsg(dpecode));
}


/* ֥Ȥ򣱣ʿɽʸȤƽϤ롣 */
void printobjhex(const char *obj, int size){
  int i;
  for(i = 0; i < size; i++){
    printf("%s%02X", i > 0 ? " " : "", obj[i]);
  }
}


/* ǡ١ե롣 */
int docreate(const char *name, int bnum){
  DEPOT *depot;
  if(!(depot = dpopen(name, DP_OWRITER | DP_OCREAT | DP_OTRUNC, bnum))){
    pdperror(name);
    return 1;
  }
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* ͤб쥳ɤɲä롣 */
int doput(const char *name, const char *kbuf, int ksiz, const char *vbuf, int vsiz, DPDMODE dmode){
  DEPOT *depot;
  if(!(depot = dpopen(name, DP_OWRITER, -1))){
    pdperror(name);
    return 1;
  }
  if(!dpsetalign(depot, ALIGNSIZE, ALIGNUNIT)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(!dpput(depot, kbuf, ksiz, vbuf, vsiz, dmode)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* б쥳ɤ롣 */
int doout(const char *name, const char *kbuf, int ksiz){
  DEPOT *depot;
  if(!(depot = dpopen(name, DP_OWRITER, -1))){
    pdperror(name);
    return 1;
  }
  if(!dpout(depot, kbuf, ksiz)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* б쥳ɤͤɸϤ롣 */
int doget(const char *name, const char *kbuf, int ksiz, int start, int max, int ox, int nb){
  DEPOT *depot;
  char *vbuf;
  int vsiz;
  if(!(depot = dpopen(name, DP_OREADER, -1))){
    pdperror(name);
    return 1;
  }
  if(!(vbuf = dpget(depot, kbuf, ksiz, start, max, &vsiz))){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(ox){
    printobjhex(vbuf, vsiz);
  } else {
    printf("%s", vbuf);
  }
  free(vbuf);
  if(!nb) putchar('\n');
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* ǡ١ƤΥ쥳ɤΥԤǶڤäɸϤ롣 */
int dolist(const char *name, int ox){
  DEPOT *depot;
  char *kbuf;
  int ksiz;
  if(!(depot = dpopen(name, DP_OREADER, -1))){
    pdperror(name);
    return 1;
  }
  dpiterinit(depot);
  while((kbuf = dpiternext(depot, &ksiz)) != NULL){
    if(ox){
      printobjhex(kbuf, ksiz);
      putchar('\n');
    } else {
      printf("%s\n", kbuf);
    }    
    free(kbuf);
  }
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* ǡ١Ŭ롣 */
int dooptimize(const char *name, int bnum){
  DEPOT *depot;
  if(!(depot = dpopen(name, DP_OWRITER, -1))){
    pdperror(name);
    return 1;
  }
  if(!dpsetalign(depot, ALIGNSIZE, ALIGNUNIT)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(!dpoptimize(depot, bnum)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}


/* ǡ١λ¿ʾϤ롣 */
int doinform(const char *name){
  DEPOT *depot;
  if(!(depot = dpopen(name, DP_OREADER, -1))){
    pdperror(name);
    return 1;
  }
  printf("name: %s\n", dpname(depot));
  printf("file size: %d\n", dpfsiz(depot));
  printf("all buckets: %d\n", dpbnum(depot));
  printf("used buckets: %d\n", dpbusenum(depot));
  printf("records: %d\n", dprnum(depot));
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}



/* END OF FILE */
