/*************************************************************************************************
 * dptest
 * DepotΥƥȥ
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    ʰץǡ١롼DepotΥƥȥǤ롣ǽƥȤǽƥȤͤ롣
 *    ʲν񼰤Ѥ롣name ϥե̾rnum ϥ쥳ɿbnum ϥХåǿ
 *      ꤹ롣
 *       - 00000001ס00000002פΤ褦Ѳ8ХȤΥŬ8ХȤͤϢ³ƥǡ
 *         ١ɲä롣
 *            dptest write [-cat num] [-asiz num] [-aunit aunit] name rnum bnum
 *       - 嵭ǡ١쥳ɤ򸡺롣
 *            dptest read name
 *       - ƼȤ߹碌ƥȤԤ
 *            dptest combo name
 *       - ƥץϰʲεǽġ
 *            -cat num   num β򷫤֤ƥνʣ򵯤Ϣ⡼ɤǽ롣
 *            -asiz num  饤Ȥδܥ num ꤹ롣
 *            -aunit num 饤ȤΥ˥åȥ num ˻ꤹ롣
 *    dptest Ͻ˽λ 0 ֤顼Фʳ֤ͤƽλ롣
 *************************************************************************************************/


#include "depot.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Хѿ */
const char *progname;               /* ץ̾ */


/* ؿץȥ */
int main(int argc, char **argv);
void usage(void);
int runwrite(int argc, char **argv);
int runread(int argc, char **argv);
int runcombo(int argc, char **argv);
void pdperror(const char *name);
int dowrite(const char *name, int rnum, int bnum, int repeat, int asiz, int aunit);
int doread(const char *name);
int docombo(const char *name);


/* ᥤ롼 */
int main(int argc, char **argv){
  int rv;
  progname = argv[0];
  if(argc < 2) usage();
  rv = 0;
  if(!strcmp(argv[1], "write")){
    rv = runwrite(argc, argv);
  } else if(!strcmp(argv[1], "read")){
    rv = runread(argc, argv);
  } else if(!strcmp(argv[1], "combo")){
    rv = runcombo(argc, argv);
  } else {
    usage();
  }
  return rv;
}


/* ˡåϤƽλ롣 */
void usage(void){
  fprintf(stderr, "%s: test cases for Depot\n\n", progname);
  fprintf(stderr, "usage:\n");
  fprintf(stderr, "  %s write [-cat num] [-asiz num] [-aunit aunit] name rnum bnum\n", progname);
  fprintf(stderr, "  %s read name\n", progname);
  fprintf(stderr, "  %s combo name\n", progname);
  exit(1);
}


/* writeΰϤ롣 */
int runwrite(int argc, char **argv){
  char *name, *rstr, *bstr;
  int i, rnum, bnum, repeat, asiz, aunit, rv;
  name = NULL;
  rstr = NULL;
  bstr = NULL;
  rnum = 0;
  bnum = 0;
  repeat = 1;
  asiz = 1;
  aunit = 0;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-cat")){
        if(++i >= argc) usage();
        repeat = atoi(argv[i]);
      } else if(!strcmp(argv[i], "-asiz")){
        if(++i >= argc) usage();
        asiz = atoi(argv[i]);
      } else if(!strcmp(argv[i], "-aunit")){
        if(++i >= argc) usage();
        aunit = atoi(argv[i]);
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else if(!rstr){
      rstr = argv[i];
    } else if(!bstr){
      bstr = argv[i];
    } else {
      usage();
    }
  }
  if(!name || !rstr || !bstr) usage();
  rnum = atoi(rstr);
  bnum = atoi(bstr);
  if(rnum < 1 || bnum < 1 || repeat < 1 || asiz < 1 || aunit < 0) usage();
  rv = dowrite(name, rnum, bnum, repeat, asiz, aunit);
  return rv;
}


/* readΰϤ롣 */
int runread(int argc, char **argv){
  char *name;
  int i, rv;
  name = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      usage();
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = doread(name);
  return rv;
}


/* comboΰϤ롣 */
int runcombo(int argc, char **argv){
  char *name;
  int i, rv;
  name = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      usage();
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = docombo(name);
  return rv;
}


/* depotΥ顼åϤ롣 */
void pdperror(const char *name){
  fprintf(stderr, "%s: %s: %s\n", progname, name, dperrmsg(dpecode));
}


/* 񤭹ߤΥƥȤԤ */
int dowrite(const char *name, int rnum, int bnum, int repeat, int asiz, int aunit){
  DEPOT *depot;
  int i, ri, err, len;
  char buf[32];
  printf("<Writing Test>\n  name=%s  rnum=%d  bnum=%d  repeat=%d  asiz=%d  aunit=%d\n\n",
         name, rnum, bnum, repeat, asiz, aunit);
  /* ǡ١򳫤 */
  if(!(depot = dpopen(name, DP_OWRITER | DP_OCREAT | DP_OTRUNC, bnum))){
    pdperror(name);
    return 1;
  }
  /* 饤Ȥ */
  if(asiz > 0 && aunit > 0){
    if(!dpsetalign(depot, asiz, aunit)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  /* ԡȤβ */
  err = FALSE;
  for(ri = 1; ri <= repeat; ri++){
    if(repeat > 1) printf("Repeat: %d\n", ri);
    /* 쥳ɿ */
    for(i = 1; i <= rnum; i++){
      len = sprintf(buf, "%08d", i);
      /* 쥳ɤɲ */
      if(!dpput(depot, buf, len, buf, len, DP_DCAT)){
        pdperror(name);
        err = TRUE;
        break;
      }
      /* вν */
      if(rnum > 200 && i % (rnum / 200) == 0){
        putchar('.');
        fflush(stdout);
        if(i == rnum || i % (rnum / 10) == 0){
          printf(" (%08d)\n", i);
          fflush(stdout);
        }
      }
    }
    if(err) break;
  }
  /* ǡ١Ĥ */
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  if(!err) printf("ok\n\n");
  return err ? 1 : 0;
}


/* ɤ߹ߤΥƥȤԤ */
int doread(const char *name){
  DEPOT *depot;
  int i, rnum, err, len;
  char buf[32], *val;
  printf("<Reading Test>\n  name=%s\n\n", name);
  /* ǡ١򳫤 */
  if(!(depot = dpopen(name, DP_OREADER, -1))){
    pdperror(name);
    return 1;
  }
  /* 쥳ɿμ */
  rnum = dprnum(depot);
  err = FALSE;
  /* 쥳ɿʬ */
  for(i = 1; i <= rnum; i++){
    len = sprintf(buf, "%08d", i);
    if(!(val = dpget(depot, buf, len, 0, -1, NULL))){
      pdperror(name);
      err = TRUE;
      break;
    }
    free(val);
    /* вν */
    if(rnum > 200 && i % (rnum / 200) == 0){
      putchar('.');
      fflush(stdout);
      if(i == rnum || i % (rnum / 10) == 0){
        printf(" (%08d)\n", i);
        fflush(stdout);
      }
    }
  }
  /* ǡ١Ĥ */
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  if(!err) printf("ok\n\n");
  return err ? 1 : 0;  
}


/* Ȥ߹碌ƥȤԤ */
int docombo(const char *name){
  DEPOT *depot;
  char buf[32], wbuf[32], *vbuf;
  int i, len, wlen, vsiz;
  printf("<Combination Test>\n  name=%s\n\n", name);
  /* ХåȤǤ1Ĥǥǡ١򳫤 */
  printf("Creating a database with bnum 3 ... ");
  if(!(depot = dpopen(name, DP_OWRITER | DP_OCREAT | DP_OTRUNC, 3))){
    pdperror(name);
    return 1;
  }
  printf("ok\n");
  /* 饤Ȥ16/64 */
  printf("Setting alignment with asiz 16 and aunit 64 ... ");
  if(!dpsetalign(depot, 16, 64)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  printf("ok\n");
  /* 20Ͽ */
  printf("Adding 20 records ... ");
  for(i = 1; i <= 20; i++){
    len = sprintf(buf, "%08d", i);
    if(!dpput(depot, buf, len, buf, len, DP_DOVER)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* Ͽǧ */
  printf("Checking records ... ");
  for(i = 1; i <= 20; i++){
    len = sprintf(buf, "%08d", i);
    if(!(vbuf = dpget(depot, buf, len, 0, -1, &vsiz))){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
    free(vbuf);
    if(vsiz != dpvsiz(depot, buf, len)){
      fprintf(stderr, "%s: %s: invalid vsiz\n", progname, name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* 10Ǥޤǰưȼʤ񤭤򤹤 */
  printf("Overwriting top 10 records without moving rooms ... ");
  for(i = 1; i <= 10; i++){
    len = sprintf(buf, "%08d", i);
    if(!dpput(depot, buf, len, buf, len, DP_DOVER)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* 5Ǥޤǰưȼ񤭤򤹤 */
  printf("Overwriting top 5 records with moving rooms ... ");
  for(i = 1; i <= 5; i++){
    len = sprintf(buf, "%08d", i);
    wlen = sprintf(wbuf, "%024d", i);
    if(!dpput(depot, buf, len, wbuf, wlen, DP_DOVER)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* 15ǤޤǰưȼϢ򤹤 */
  printf("Overwriting top 15 records in concatenation with moving rooms ... ");
  for(i = 1; i <= 15; i++){
    len = sprintf(buf, "%08d", i);
    wlen = sprintf(wbuf, "========================");
    if(!dpput(depot, buf, len, wbuf, wlen, DP_DCAT)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* Ͽǧ */
  printf("Checking records ... ");
  for(i = 1; i <= 20; i++){
    len = sprintf(buf, "%08d", i);
    if(!(vbuf = dpget(depot, buf, len, 0, -1, &vsiz))){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
    free(vbuf);
    if(vsiz != dpvsiz(depot, buf, len)){
      fprintf(stderr, "%s: %s: invalid vsiz\n", progname, name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* 10ǤޤǺ */
  printf("Deleting top 10 records ...");
  for(i = 1; i <= 10; i++){
    len = sprintf(buf, "%08d", i);
    if(!dpout(depot, buf, len)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* ǧ */
  printf("Checking deleted records ... ");
  for(i = 1; i <= 10; i++){
    len = sprintf(buf, "%08d", i);
    vbuf = dpget(depot, buf, len, 0, -1, &vsiz);
    free(vbuf);
    if(vbuf || dpecode != DP_ENOITEM){
      fprintf(stderr, "%s: %s: deleting failed\n", progname, name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* 15ǤޤǰưȼϢ򤹤 */
  printf("Overwriting top 15 records in concatenation with moving rooms ...");
  for(i = 1; i <= 15; i++){
    len = sprintf(buf, "%08d", i);
    wlen = sprintf(wbuf, "========================");
    if(!dpput(depot, buf, len, wbuf, wlen, DP_DCAT)){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* Ͽǧ */
  printf("Checking records ... ");
  for(i = 1; i <= 20; i++){
    len = sprintf(buf, "%08d", i);
    if(!(vbuf = dpget(depot, buf, len, 0, -1, &vsiz))){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
    free(vbuf);
    if(vsiz != dpvsiz(depot, buf, len)){
      fprintf(stderr, "%s: %s: invalid vsiz\n", progname, name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* Ŭ */
  printf("Optimizing database ... ");
  if(!dpoptimize(depot, -1)){
    pdperror(name);
    dpclose(depot);
    return 1;
  }
  printf("ok\n");
  /* Ͽǧ */
  printf("Checking records ... ");
  for(i = 1; i <= 20; i++){
    len = sprintf(buf, "%08d", i);
    if(!(vbuf = dpget(depot, buf, len, 0, -1, &vsiz))){
      pdperror(name);
      dpclose(depot);
      return 1;
    }
    free(vbuf);
    if(vsiz != dpvsiz(depot, buf, len)){
      fprintf(stderr, "%s: %s: invalid vsiz\n", progname, name);
      dpclose(depot);
      return 1;
    }
  }
  printf("ok\n");
  /* ǡ١Ĥ */
  printf("Closing database ... ");
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  printf("ok\n");
  printf("all ok\n\n");
  return 0;
}



/* END OF FILE */
