/*************************************************************************************************
 * dptsv
 * TSVեDepotΥǡ١Ѵġ
 *                                                       Copyright(c) 2000-2003 Mikio Hirabayashi
 * 
 *    ֶڤǥͤɽԤʤTSVեDepotΥǡ١Ѵ롣
 *    TSVեɤ߹ǥǡ١ϡʲν񼰤Ѥ롣
 *        dptsv import [-bnum num] name
 *    name Ϻǡ١̾ꤹ롣-bnum ץ num ϥХåǿ
 *      ꤹ롣TSVΥǡɸϤɤ߹ࡣʣ쥳ɤϸԤͥ褹롣
 *    ǡ١ƤΥ쥳ɤTSVեȤƽϤϡʲν񼰤Ѥ롣
 *        dptsv export name
 *    name Ϻǡ١̾ꤹ롣TSVΥǡɸϤ롣
 *    ˽λ 0 ֤顼Фʳ֤ͤƽλ롣
 *************************************************************************************************/


#include "depot.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>


/* Хѿ */
const char *progname;               /* ץ̾ */


/* ؿץȥ */
int main(int argc, char **argv);
void usage(void);
int runimport(int argc, char **argv);
int runexport(int argc, char **argv);
void pdperror(const char *name);
char *getl(void);
int doimport(const char *name, int bnum);
int doexport(const char *name);


/* ᥤ롼 */
int main(int argc, char **argv){
  int rv;
  progname = argv[0];
  if(argc < 2) usage();
  rv = 0;
  if(!strcmp(argv[1], "import")){
    rv = runimport(argc, argv);
  } else if(!strcmp(argv[1], "export")){
    rv = runexport(argc, argv);
  } else {
    usage();
  }
  return rv;
}


/* ˡåϤƽλ롣 */
void usage(void){
  fprintf(stderr, "%s: mutual converter between TSV and Depot database\n\n", progname);
  fprintf(stderr, "usage:\n");
  fprintf(stderr, "  %s import [-bnum num] name\n", progname);
  fprintf(stderr, "  %s export name\n", progname);
  exit(1);
}


/* importΰϤ롣 */
int runimport(int argc, char **argv){
  char *name;
  int i, bnum, rv;
  name = NULL;
  bnum = -1;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      if(!strcmp(argv[i], "-bnum")){
        if(++i >= argc) usage();
        bnum = atoi(argv[i]);
      } else {
        usage();
      }
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = doimport(name, bnum);
  return rv;
}


/* exportΰϤ롣 */
int runexport(int argc, char **argv){
  char *name;
  int i, rv;
  name = NULL;
  for(i = 2; i < argc; i++){
    if(!name && argv[i][0] == '-'){
      usage();
    } else if(!name){
      name = argv[i];
    } else {
      usage();
    }
  }
  if(!name) usage();
  rv = doexport(name);
  return rv;
}


/* depotΥ顼åϤ롣 */
void pdperror(const char *name){
  fprintf(stderr, "%s: %s: %s\n", progname, name, dperrmsg(dpecode));
}


/* ɸϤ飱ɤ߹ǥȤΰ˳ǼΥݥ󥿤֤
   եνޤɤ NULL ֤ */
char *getl(void){
  char *buf;
  int c, len, blen;
  buf = NULL;
  len = 0;
  blen = 256;
  while((c = getchar()) != EOF){
    if(blen <= len) blen *= 2;
    if(!(buf = realloc(buf, blen + 1))){
      fprintf(stderr, "out of memory\n");
      exit(1);
    }
    if(c == '\n') c = '\0';
    buf[len++] = c;
    if(c == '\0') break;
  }
  if(!buf) return NULL;
  buf[len] = '\0';
  return buf;
}


/* TSVեɤ߹ǥǡ١롣 */
int doimport(const char *name, int bnum){
  DEPOT *depot;
  char *buf, *key, *val;
  int i, err;
  /* ǡ١򳫤 */
  if(!(depot = dpopen(name, DP_OWRITER | DP_OCREAT, bnum))){
    pdperror(name);
    return 1;
  }
  /* ɸϤ飱Ԥɤ߹ǽ */
  err = FALSE;
  for(i = 1; (buf = getl()) != NULL; i++){
    key = buf;
    if((val = strchr(buf, '\t')) != NULL){
      *val = '\0';
      val++;
      /* 쥳ɤɲ */
      if(!dpput(depot, key, -1, val, -1, DP_DOVER)){
        pdperror(name);
        err = TRUE;
        break;
      }
    } else {
      fprintf(stderr, "%s: %s: invalid format in line %d\n", progname, name, i);
    }
    free(buf);
    if(err) break;
  }
  /* ǡ١Ĥ */
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return err ? 1 : 0;
}


/* ǡ١ƤΥ쥳ɤTSVեȤƽϤ롣 */
int doexport(const char *name){
  DEPOT *depot;
  char *key, *val;
  /* ǡ١򳫤 */
  if(!(depot = dpopen(name, DP_OREADER, -1))){
    pdperror(name);
    return 1;
  }
  /* ƥ졼ν */
  dpiterinit(depot);
  /* ƤΥФƽ */
  while((key = dpiternext(depot, NULL)) != NULL){
    /* бͤθ */
    val = dpget(depot, key, -1, 0, -1, NULL);
    if(key && val) printf("%s\t%s\n", key, val);
    free(val);
    free(key);
  }
  /* ǡ١Ĥ */
  if(!dpclose(depot)){
    pdperror(name);
    return 1;
  }
  return 0;
}



/* END OF FILE */
